<template>
  <pageWrapper
    :title="$t('authorization.sign_up')"
    :gradient="true"
    closable
    @close="close"
    :hideFooter="true"
    ref="pageWrapper">
    <template slot="subtitle">
      <div class="signIn_title">
        <div
          class="container-plain">
          <div
            class="signIn_title-back"
            @click="prevStep"
            v-show="step!==1 && passedSteps['step' + (step-1)]">
            <i class="i-icon-arrow-left"></i>
          </div>
          {{$t('authorization.step')}} {{step}} {{$t('common.of')}} 3
          <div
            class="signIn_title-next"
            :class="!passedSteps['step' + step] ? 'signIn_title-disabled' : ''"
            @click="nextStep"
            v-show="step!==3">
            <i class="i-icon-arrow-right"></i>
          </div>
        </div>
      </div>
    </template>
    <transition
      :name="animation"
      mode="out-in">
      <components
        @nextStep="nextStep"
        @close="close"
        :step="step"
        :is="activeComponent"></components>
    </transition>
  </pageWrapper>
</template>

<script>
  import pageWrapper from '~/components/common/pageWrapper';
  import TheStep1 from '~/components/signIn/TheStep1';
  import TheStep2 from '~/components/signIn/TheStep2';
  import TheStep3 from '~/components/signIn/TheStep3';

  export default {
    name: "SignIn",
    data() {
      return {
        step: 1,
        activeComponent: 'TheStep1',
        animation: 'slideTo-left',
      }
    },
    components: {
      pageWrapper,
      TheStep1,
      TheStep2,
      TheStep3
    },
    computed: {
      isAuth() {
        return this.$store.state.user.isAuth;
      },
      passedSteps() {
        return this.$store.state.signIn.passed;
      }
    },
    methods: {
      prevStep() {
        this.animation = 'slideTo-right';
        this.changeComponent(-1);
      },
      nextStep() {
        if (!this.passedSteps['step' + this.step]) return;
        this.animation = 'slideTo-left';
        this.changeComponent(1);
      },
      changeComponent(step) {
        this.step = this.step + step;
        this.activeComponent = 'TheStep' + this.step;
        document.querySelector('.header_top .page') && document.querySelector('.header_top .page').classList.remove('page-sticky');
        this.$nextTick(_ => {
          const el = this.$refs['pageWrapper'].$el;
          el.scrollTo(0, 0);
        });
      },
      close() {
        this.$emit('close');
      }
    }
  }
</script>
